Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_merge.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_merge.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_merge.cpp	(revision 1134)
@@ -0,0 +1,286 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+
+namespace ep_lib {
+
+  int MPI_Intercomm_merge_unique_leader(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
+  {
+    Debug("intercomm_merge with unique leader\n");
+
+
+
+    int ep_rank, ep_rank_loc, mpi_rank;
+    int ep_size, num_ep, mpi_size;
+
+    ep_rank = inter_comm.ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = inter_comm.ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = inter_comm.ep_comm_ptr->size_rank_info[2].first;
+    ep_size = inter_comm.ep_comm_ptr->size_rank_info[0].second;
+    num_ep = inter_comm.ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = inter_comm.ep_comm_ptr->size_rank_info[2].second;
+
+    int local_high = high;
+    int remote_high;
+
+    int remote_ep_size = inter_comm.ep_comm_ptr->intercomm->remote_rank_map->size();
+
+    int local_ep_rank, local_ep_rank_loc, local_mpi_rank;
+    int local_ep_size, local_num_ep, local_mpi_size;
+
+    local_ep_rank = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].first;
+    local_ep_rank_loc = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].first;
+    local_mpi_rank = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].first;
+    local_ep_size = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].second;
+    local_num_ep = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].second;
+    local_mpi_size = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].second;
+
+
+    if(local_ep_rank == 0)
+    {
+      MPI_Status status;
+      MPI_Request req_s, req_r;
+      MPI_Isend(&local_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &req_s);
+      MPI_Irecv(&remote_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &req_r);
+
+      MPI_Wait(&req_s, &status);
+      MPI_Wait(&req_r, &status);
+    }
+
+
+    MPI_Bcast(&remote_high, 1, MPI_INT, 0, *(inter_comm.ep_comm_ptr->intercomm->local_comm));
+
+//    printf("%d, %d, %d, %d\n", local_ep_size, remote_ep_size, local_high, remote_high);
+
+
+    MPI_Comm_dup(inter_comm, newintracomm);
+
+    int my_ep_rank = local_high<remote_high? local_ep_rank: local_ep_rank+remote_ep_size;
+
+
+    int intra_ep_rank, intra_ep_rank_loc, intra_mpi_rank;
+    int intra_ep_size, intra_num_ep, intra_mpi_size;
+
+    intra_ep_rank = newintracomm->ep_comm_ptr->size_rank_info[0].first;
+    intra_ep_rank_loc = newintracomm->ep_comm_ptr->size_rank_info[1].first;
+    intra_mpi_rank = newintracomm->ep_comm_ptr->size_rank_info[2].first;
+    intra_ep_size = newintracomm->ep_comm_ptr->size_rank_info[0].second;
+    intra_num_ep = newintracomm->ep_comm_ptr->size_rank_info[1].second;
+    intra_mpi_size = newintracomm->ep_comm_ptr->size_rank_info[2].second;
+
+
+    MPI_Barrier_local(*newintracomm);
+
+
+    int *reorder;
+    if(intra_ep_rank_loc == 0)
+    {
+      reorder = new int[intra_ep_size];
+    }
+
+
+    MPI_Gather(&my_ep_rank, 1, MPI_INT, reorder, 1, MPI_INT, 0, *newintracomm);
+    if(intra_ep_rank_loc == 0)
+    {
+      ::MPI_Bcast(reorder, intra_ep_size, MPI_INT_STD, 0, static_cast< ::MPI_Comm>(newintracomm->mpi_comm));
+
+      vector< pair<int, int> > tmp_rank_map(intra_ep_size);
+
+
+      for(int i=0; i<intra_ep_size; i++)
+      {
+        tmp_rank_map[reorder[i]] = newintracomm->rank_map->at(i) ;
+      }
+
+      newintracomm->rank_map->swap(tmp_rank_map);
+
+      tmp_rank_map.clear();
+    }
+
+    MPI_Barrier_local(*newintracomm);
+
+    (*newintracomm).ep_comm_ptr->size_rank_info[0].first = my_ep_rank;
+
+    if(intra_ep_rank_loc == 0)
+    {
+      delete[] reorder;
+    }
+
+    return MPI_SUCCESS;
+  }
+
+
+
+
+
+  int MPI_Intercomm_merge(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
+  {
+
+    assert(inter_comm.is_intercomm);
+
+    if(inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->comm_label == -99)
+    {
+        return MPI_Intercomm_merge_unique_leader(inter_comm, high, newintracomm);
+    }
+
+
+    Debug("intercomm_merge kernel\n");
+
+    int ep_rank, ep_rank_loc, mpi_rank;
+    int ep_size, num_ep, mpi_size;
+
+    ep_rank = inter_comm.ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = inter_comm.ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = inter_comm.ep_comm_ptr->size_rank_info[2].first;
+    ep_size = inter_comm.ep_comm_ptr->size_rank_info[0].second;
+    num_ep = inter_comm.ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = inter_comm.ep_comm_ptr->size_rank_info[2].second;
+
+
+    int local_ep_rank, local_ep_rank_loc, local_mpi_rank;
+    int local_ep_size, local_num_ep, local_mpi_size;
+
+
+    local_ep_rank = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].first;
+    local_ep_rank_loc = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].first;
+    local_mpi_rank = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].first;
+    local_ep_size = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].second;
+    local_num_ep = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].second;
+    local_mpi_size = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].second;
+
+    int remote_ep_size = inter_comm.ep_comm_ptr->intercomm->remote_rank_map->size();
+
+    int local_high = high;
+    int remote_high;
+
+    MPI_Barrier(inter_comm);
+
+//    if(local_ep_rank == 0 && high == false)
+//    {
+//      MPI_Status status;
+//      MPI_Send(&local_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm);
+//      MPI_Recv(&remote_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &status);
+//    }
+//
+//    if(local_ep_rank == 0 && high == true)
+//    {
+//      MPI_Status status;
+//      MPI_Recv(&remote_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &status);
+//      MPI_Send(&local_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm);
+//    }
+
+    if(local_ep_rank == 0)
+    {
+      MPI_Status status;
+      MPI_Request req_s, req_r;
+      MPI_Isend(&local_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &req_s);
+      MPI_Irecv(&remote_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &req_r);
+
+      MPI_Wait(&req_s, &status);
+      MPI_Wait(&req_r, &status);
+    }
+
+    MPI_Bcast(&remote_high, 1, MPI_INT, 0, *(inter_comm.ep_comm_ptr->intercomm->local_comm));
+
+    int intercomm_high;
+    if(ep_rank == 0) intercomm_high = local_high;
+    MPI_Bcast(&intercomm_high, 1, MPI_INT, 0, inter_comm);
+
+    //printf("remote_ep_size = %d, local_high = %d, remote_high = %d, intercomm_high = %d\n", remote_ep_size, local_high, remote_high, intercomm_high);
+
+
+    ::MPI_Comm mpi_intracomm;
+    MPI_Comm *ep_intracomm;
+
+    if(ep_rank_loc == 0)
+    {
+
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm>(inter_comm.ep_comm_ptr->intercomm->mpi_inter_comm);
+
+      ::MPI_Intercomm_merge(mpi_comm, intercomm_high, &mpi_intracomm);
+      MPI_Info info;
+      MPI_Comm_create_endpoints(mpi_intracomm, num_ep, info, ep_intracomm);
+
+      inter_comm.ep_comm_ptr->comm_list->mem_bridge = ep_intracomm;
+
+    }
+
+
+
+    MPI_Barrier_local(inter_comm);
+
+    *newintracomm = inter_comm.ep_comm_ptr->comm_list->mem_bridge[ep_rank_loc];
+
+    int my_ep_rank = local_high<remote_high? local_ep_rank: local_ep_rank+remote_ep_size;
+
+    int intra_ep_rank, intra_ep_rank_loc, intra_mpi_rank;
+    int intra_ep_size, intra_num_ep, intra_mpi_size;
+
+    intra_ep_rank = newintracomm->ep_comm_ptr->size_rank_info[0].first;
+    intra_ep_rank_loc = newintracomm->ep_comm_ptr->size_rank_info[1].first;
+    intra_mpi_rank = newintracomm->ep_comm_ptr->size_rank_info[2].first;
+    intra_ep_size = newintracomm->ep_comm_ptr->size_rank_info[0].second;
+    intra_num_ep = newintracomm->ep_comm_ptr->size_rank_info[1].second;
+    intra_mpi_size = newintracomm->ep_comm_ptr->size_rank_info[2].second;
+
+
+
+    MPI_Barrier_local(*newintracomm);
+
+
+    int *reorder;
+    if(intra_ep_rank_loc == 0)
+    {
+      reorder = new int[intra_ep_size];
+    }
+
+
+
+    MPI_Gather(&my_ep_rank, 1, MPI_INT, reorder, 1, MPI_INT, 0, *newintracomm);
+    if(intra_ep_rank_loc == 0)
+    {
+
+      ::MPI_Bcast(reorder, intra_ep_size, MPI_INT_STD, 0, static_cast< ::MPI_Comm>(newintracomm->mpi_comm));
+
+      vector< pair<int, int> > tmp_rank_map(intra_ep_size);
+
+
+      for(int i=0; i<intra_ep_size; i++)
+      {
+        tmp_rank_map[reorder[i]] = newintracomm->rank_map->at(i) ;
+      }
+
+      newintracomm->rank_map->swap(tmp_rank_map);
+
+      tmp_rank_map.clear();
+    }
+
+    MPI_Barrier_local(*newintracomm);
+
+    (*newintracomm).ep_comm_ptr->size_rank_info[0].first = my_ep_rank;
+
+
+    if(intra_ep_rank_loc == 0)
+    {
+      delete[] reorder;
+
+    }
+
+    /*
+    if(intra_ep_rank == 0)
+    {
+      for(int i=0; i<intra_ep_size; i++)
+      {
+        printf("intra rank_map[%d] = (%d, %d)\n", i, newintracomm->rank_map->at(i).first, newintracomm->rank_map->at(i).second);
+      }
+    }
+*/
+    return MPI_SUCCESS;
+
+  }
+
+
+}
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_message.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_message.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_message.cpp	(revision 1134)
@@ -0,0 +1,225 @@
+/*!
+   \file ep_message.cpp
+   \since 2 may 2016
+
+   \brief Definitions of MPI endpoint function: Message_Check
+ */
+
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+namespace ep_lib
+{
+
+  int Message_Check(MPI_Comm comm)
+  {
+    int myRank;
+    MPI_Comm_rank(comm, &myRank);
+
+    if(!comm.is_ep) return 0;
+
+    if(comm.is_intercomm)
+    {
+      return  Message_Check_intercomm(comm);
+    }
+
+    int flag = true;
+    ::MPI_Message message;
+    ::MPI_Status status;
+    int mpi_source;
+
+    while(flag) // loop until the end of global queue
+    {
+      Debug("Message probing for intracomm\n");
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+      #ifdef _openmpi
+      #pragma omp critical (_mpi_call)
+      {
+        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, mpi_comm, &flag, &status);
+        if(flag)
+        {
+          Debug("find message in mpi comm \n");
+          mpi_source = status.MPI_SOURCE;
+          int tag = status.MPI_TAG;
+          ::MPI_Mprobe(mpi_source, tag, mpi_comm, &message, &status);
+
+        }
+      }
+      #elif _intelmpi
+      ::MPI_Improbe(MPI_ANY_SOURCE, MPI_ANY_TAG, mpi_comm, &flag, &message, &status); 
+      #endif
+
+      if(flag)
+      {
+
+        MPI_Message *msg_block = new MPI_Message; //printf("myRank = %d, new ok\n", myRank);
+        msg_block->mpi_message = message;  //printf("myRank = %d, msg_block->mpi_message = %d\n", myRank, msg_block->mpi_message);
+        msg_block->ep_tag = bitset<15>(status.MPI_TAG >> 16).to_ulong();  //printf("myRank = %d, msg_block->ep_tag = %d\n", myRank, msg_block->ep_tag);
+        int src_loc       = bitset<8> (status.MPI_TAG >> 8) .to_ulong();  //printf("myRank = %d, src_loc = %d\n",           myRank, src_loc);
+        int dest_loc      = bitset<8> (status.MPI_TAG)	    .to_ulong();  //printf("myRank = %d, dest_loc = %d\n",          myRank, dest_loc);
+        int src_mpi       = status.MPI_SOURCE;                            //printf("myRank = %d, src_mpi = %d\n",           myRank, src_mpi);
+             
+        msg_block->ep_src  = get_ep_rank(comm, src_loc,  src_mpi);        //printf("myRank = %d, msg_block->ep_src = %d\n",  myRank, msg_block->ep_src);
+
+        //printf("myRank = %d, probed one message, ep_src = %d, ep_dest = %d, tag = %d, message = %d\n", myRank, msg_block->ep_src, msg_block->ep_dest, msg_block->ep_tag, msg_block->mpi_message);
+        msg_block->mpi_status = new ::MPI_Status(status);
+
+        MPI_Comm* ptr_comm_list = comm.ep_comm_ptr->comm_list;
+        MPI_Comm* ptr_comm_target = &ptr_comm_list[dest_loc];
+
+
+        #pragma omp critical (_query)
+        {
+          #pragma omp flush
+          ptr_comm_target->ep_comm_ptr->message_queue->push_back(*msg_block);  
+          // printf("myRank = %d, push_back OK, ep_src = %d, ep_tag = %d, mpi_status = %p (%p)\n", myRank, 
+          //                                                                                   ptr_comm_target->ep_comm_ptr->message_queue->back().ep_src,
+          //                                                                                   ptr_comm_target->ep_comm_ptr->message_queue->back().ep_tag,
+          //                                                                                   msg_block->mpi_status, &status);
+    
+          #pragma omp flush
+        }
+        
+        delete msg_block;
+        //printf("myRank = %d, delete msg_block, queue size = %lu\n", myRank, ptr_comm_target->ep_comm_ptr->message_queue->size());
+        
+      }
+
+    }
+
+    return MPI_SUCCESS;
+  }
+
+
+
+  int Message_Check_intercomm(MPI_Comm comm)
+  {
+    if(!comm.ep_comm_ptr->intercomm->mpi_inter_comm) return 0;
+
+    Debug("Message probing for intercomm\n");
+
+    int flag = true;
+    ::MPI_Message message;
+    ::MPI_Status status;
+    int mpi_source;
+    int current_ep_rank;
+    MPI_Comm_rank(comm, &current_ep_rank);
+
+    while(flag) // loop until the end of global queue "comm.ep_comm_ptr->intercomm->mpi_inter_comm"
+    {
+      Debug("Message probing for intracomm\n");
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.ep_comm_ptr->intercomm->mpi_inter_comm);  // => mpi_intercomm
+      
+      #ifdef _openmpi
+      #pragma omp critical (_mpi_call)
+      {
+        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, mpi_comm, &flag, &status);
+        if(flag)
+        {
+          Debug("find message in mpi comm \n");
+          mpi_source = status.MPI_SOURCE;
+          int tag = status.MPI_TAG;
+          ::MPI_Mprobe(mpi_source, tag, mpi_comm, &message, &status);
+
+        }
+      }
+      #elif _intelmpi
+      ::MPI_Improbe(MPI_ANY_SOURCE, MPI_ANY_TAG, mpi_comm, &flag, &message, &status);       
+      #endif
+
+      if(flag)
+      {
+
+        MPI_Message *msg_block = new MPI_Message;
+
+        msg_block->mpi_message = message;
+        msg_block->ep_tag = bitset<15>(status.MPI_TAG >> 16).to_ulong();
+        int src_loc       = bitset<8> (status.MPI_TAG >> 8) .to_ulong();
+        int dest_loc      = bitset<8> (status.MPI_TAG)	    .to_ulong();
+        int src_mpi       = status.MPI_SOURCE;
+        int current_inter = comm.ep_comm_ptr->intercomm->local_rank_map->at(current_ep_rank).first;
+             
+        msg_block->ep_src  = get_ep_rank_intercomm(comm, src_loc,  src_mpi);
+        msg_block->mpi_status = new ::MPI_Status(status);
+
+
+        MPI_Comm* ptr_comm_list = comm.ep_comm_ptr->comm_list;
+        MPI_Comm* ptr_comm_target = &ptr_comm_list[dest_loc];
+
+
+        #pragma omp critical (_query)
+        {
+          #pragma omp flush
+          ptr_comm_target->ep_comm_ptr->message_queue->push_back(*msg_block);
+          #pragma omp flush
+        }
+        
+        delete msg_block;
+        
+      }
+
+    }
+
+    flag = true;
+    while(flag) // loop until the end of global queue "comm.mpi_comm"
+    {
+      Debug("Message probing for intracomm\n");
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+      #ifdef _openmpi
+      #pragma omp critical (_mpi_call)
+      {
+        ::MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, mpi_comm, &flag, &status);
+        if(flag)
+        {
+          Debug("find message in mpi comm \n");
+          mpi_source = status.MPI_SOURCE;
+          int tag = status.MPI_TAG;
+          ::MPI_Mprobe(mpi_source, tag, mpi_comm, &message, &status);
+
+        }
+      }
+      #elif _intelmpi
+      ::MPI_Improbe(MPI_ANY_SOURCE, MPI_ANY_TAG, mpi_comm, &flag, &message, &status);       
+      #endif
+
+      if(flag)
+      {
+
+        MPI_Message *msg_block = new MPI_Message;
+       
+        msg_block->mpi_message = message;
+        msg_block->ep_tag = bitset<15>(status.MPI_TAG >> 16).to_ulong();
+        int src_loc       = bitset<8> (status.MPI_TAG >> 8) .to_ulong();
+        int dest_loc      = bitset<8> (status.MPI_TAG)	    .to_ulong();
+        int src_mpi       = status.MPI_SOURCE;
+        int current_inter = comm.ep_comm_ptr->intercomm->local_rank_map->at(current_ep_rank).first;
+        
+        msg_block->ep_src  = get_ep_rank_intercomm(comm, src_loc, src_mpi);
+        msg_block->mpi_status = new ::MPI_Status(status);
+        
+
+        MPI_Comm* ptr_comm_list = comm.ep_comm_ptr->comm_list;
+        MPI_Comm* ptr_comm_target = &ptr_comm_list[dest_loc];
+
+
+        #pragma omp critical (_query)
+        {
+          #pragma omp flush
+          ptr_comm_target->ep_comm_ptr->message_queue->push_back(*msg_block);
+          printf("probed one message, ep_src = %d, tag = %d, mpi_status = %p (%p), message = %d\n", msg_block->ep_src, msg_block->ep_tag, msg_block->mpi_status, &status, msg_block->mpi_message);
+          #pragma omp flush
+        }
+        
+        delete msg_block;
+        
+      }
+
+    }
+
+    return MPI_SUCCESS;
+  }
+
+}
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_probe.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_probe.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_probe.cpp	(revision 1134)
@@ -0,0 +1,147 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+namespace ep_lib
+{
+
+
+
+  int MPI_Iprobe(int src, int tag, MPI_Comm comm, int *flag, MPI_Status *status)
+  {
+    *flag = false;
+
+    if(!comm.is_ep)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm >(comm.mpi_comm);
+      ::MPI_Status *mpi_status = static_cast< ::MPI_Status* >(status->mpi_status);
+      ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, mpi_comm, flag, mpi_status);
+
+      status->mpi_status = mpi_status;
+      status->ep_src = src;
+      status->ep_tag = tag;
+      return 0;
+    }
+
+    Debug("calling MPI_Iprobe EP\n");
+
+    Message_Check(comm);
+
+    #pragma omp flush
+
+    
+    //printf("iprobe, message queue size = %lu, queue = %p\n", comm.ep_comm_ptr->message_queue->size(), comm.ep_comm_ptr->message_queue);
+
+    #pragma omp flush
+
+    #pragma omp critical (_query)
+    if(!comm.ep_comm_ptr->message_queue->empty())
+    {
+      for(Message_list::iterator it = comm.ep_comm_ptr->message_queue->begin(); it!= comm.ep_comm_ptr->message_queue->end(); ++it)
+      {
+        bool src_matched = src<0? true: it->ep_src == src;
+        bool tag_matched = tag<0? true: it->ep_tag == tag;
+        
+        if(src_matched && tag_matched)        
+        {
+          Debug("find message\n");
+          // printf("iprobe, find in local message queue %p, src = %d, tag = %d\n", comm.ep_comm_ptr->message_queue, it->ep_src, it->ep_tag);
+
+          *flag = true;
+
+          ::MPI_Status mpi_status = *(static_cast< ::MPI_Status *>(it->mpi_status));
+
+          status->mpi_status = new ::MPI_Status(mpi_status);
+          status->ep_src = it->ep_src;
+          status->ep_tag = it->ep_tag;
+
+          break;
+        }
+
+      }
+    }
+
+    return 0;
+  }
+
+
+
+  int MPI_Improbe(int src, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status)
+  {
+    *flag = false;
+    if(!comm.is_ep)
+    {
+      Debug("calling MPI_Improbe MPI\n");
+
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm>(comm.mpi_comm);
+      ::MPI_Status mpi_status;
+      ::MPI_Message mpi_message;
+
+      #ifdef _openmpi
+      #pragma omp critical (_mpi_call)
+      {
+        ::MPI_Iprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, mpi_comm, flag, &mpi_status);
+        if(*flag)
+        {
+          ::MPI_Mprobe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, mpi_comm, &mpi_message, &mpi_status);
+        }
+      }
+      #elif _intelmpi
+    	::MPI_Improbe(src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, mpi_comm, flag, &mpi_message, &mpi_status);
+      #endif
+    	
+      status->mpi_status = new ::MPI_Status(mpi_status);
+      status->ep_src = src;
+      status->ep_tag = tag;
+
+      message->mpi_message = mpi_message;
+      message->ep_src = src;
+      message->ep_tag = tag;
+      return 0;
+    }
+
+    
+    Message_Check(comm);
+
+    #pragma omp flush
+
+    #pragma omp critical (_query)
+    if(! comm.ep_comm_ptr->message_queue->empty())
+    {
+      for(Message_list::iterator it = comm.ep_comm_ptr->message_queue->begin(); it!= comm.ep_comm_ptr->message_queue->end(); ++it)
+      {
+        bool src_matched = src<0? true: it->ep_src == src;
+        bool tag_matched = tag<0? true: it->ep_tag == tag;
+        
+        if(src_matched && tag_matched)
+        {
+          *flag = true;
+
+          ::MPI_Status mpi_status;
+          mpi_status = *(static_cast< ::MPI_Status *>(it->mpi_status));
+
+          status->mpi_status = new ::MPI_Status(mpi_status);
+          status->ep_src = it->ep_src;
+          status->ep_tag = it->ep_tag;
+
+          message->mpi_message = it->mpi_message;
+          message->ep_tag = it->ep_tag;
+          message->ep_src = it->ep_src;
+
+          #pragma omp critical (_query2)
+          {              
+            //printf("local message erased. src = %d, dest = %d, tag = %d\n", it->ep_src, it->ep_dest, it->ep_tag);     
+            delete it->mpi_status;
+            comm.ep_comm_ptr->message_queue->erase(it);
+            #pragma omp flush
+          }
+
+          break;
+        }
+
+      }
+    }
+  }
+
+}
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_rank.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_rank.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_rank.cpp	(revision 1134)
@@ -0,0 +1,50 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+namespace ep_lib
+{
+
+
+
+  int MPI_Comm_rank(MPI_Comm comm, int* rank)
+  {
+
+    if(comm.is_ep)
+    {
+      Debug("Calling EP_Comm_rank\n");
+
+      if(comm.is_intercomm)
+      {
+        *rank = comm.ep_comm_ptr->intercomm->size_rank_info[0].first;
+        return 0;
+      }
+      else
+      {
+        *rank = comm.ep_comm_ptr->size_rank_info[0].first;
+        return 0;
+      }
+    }
+
+
+    if(comm != MPI_COMM_NULL)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+      ::MPI_Comm_rank(mpi_comm, rank);
+      return 0;
+    }
+    else
+    {
+      printf("rank is undefined\n");
+
+      *rank = MPI_UNDEFINED;
+      return 0;
+    }
+
+  }
+
+
+
+}
+
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_recv.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_recv.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_recv.cpp	(revision 1134)
@@ -0,0 +1,141 @@
+/*!
+   \file ep_recv.cpp
+   \since 2 may 2016
+
+   \brief Definitions of MPI receive functions: MPI_Recv, MPI_Mrecv, MPI_Irecv, MPI_Imrecv
+ */
+
+
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+
+namespace ep_lib {
+
+	int MPI_Recv(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Status *status)
+	{
+    int dest_rank;
+    MPI_Comm_rank(comm, &dest_rank);
+
+    if(!comm.is_ep)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm >(comm.mpi_comm);
+      ::MPI_Status mpi_status;
+      ::MPI_Recv(buf, count, static_cast< ::MPI_Datatype >(datatype), src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, mpi_comm, &mpi_status);
+
+      status->ep_src = src;
+      status->ep_tag = tag;
+      status->ep_datatype = datatype;
+
+      return 0;  
+    }
+
+    Message_Check(comm);
+
+    MPI_Request request;
+    MPI_Irecv(buf, count, datatype, src, tag, comm, &request);
+    MPI_Wait(&request, status);
+
+    return 0;
+	}
+
+
+
+
+	int MPI_Irecv(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Request *request)
+	{
+
+		Debug("MPI_Irecv with EP");
+    int dest_rank;
+    MPI_Comm_rank(comm, &dest_rank);
+
+ 		if(!comm.is_ep)
+		{
+		  ::MPI_Request mpi_request;
+		  ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+		  ::MPI_Irecv(buf, count, static_cast< ::MPI_Datatype> (datatype), src<0? MPI_ANY_SOURCE : src, tag<0? MPI_ANY_TAG: tag, mpi_comm, &mpi_request);
+
+		  request->mpi_request = mpi_request;
+      request->ep_src = src;
+      request->ep_datatype = datatype;
+      request->ep_tag = tag;
+		}
+
+		Message_Check(comm);
+		
+
+		request->mpi_request = MPI_REQUEST_NULL_STD;
+		request->buf = buf;
+    request->comm = comm;
+		request->type = 2;
+
+		request->ep_src = src;
+    request->ep_tag = tag;
+    request->ep_datatype = datatype;
+
+
+    
+		/* With Improbe*/
+		Message_Check(comm);
+
+    int flag = false;
+    MPI_Message message;
+    MPI_Status status;
+    
+    MPI_Improbe(src, tag, comm, &flag, &message, &status);
+            
+    if(flag)
+    {
+      MPI_Imrecv(buf, count, datatype, &message, request);
+    }
+
+    return 0;
+	}
+
+	int MPI_Imrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message, MPI_Request *request)
+	{
+		Debug("MPI_Imrecv");
+
+		request->type = 3;
+
+    ::MPI_Request mpi_request;
+    ::MPI_Message mpi_message = static_cast< ::MPI_Message >(message->mpi_message);
+		
+		::MPI_Imrecv(buf, count, static_cast< ::MPI_Datatype>(datatype), &mpi_message, &mpi_request);
+
+    request->mpi_request = mpi_request;
+    request->ep_datatype = datatype;
+    request->ep_tag = message->ep_tag;
+    request->ep_src = message->ep_src;
+    request->buf = buf;
+
+    return 0;
+	}
+
+
+  int MPI_Mrecv(void *buf, int count, MPI_Datatype datatype, MPI_Message *message, MPI_Status *status)
+	{
+    Debug("EP Mrecv called\n");
+
+    ::MPI_Status mpi_status;
+    ::MPI_Message mpi_message = static_cast< ::MPI_Message >(message->mpi_message);
+		
+		::MPI_Mrecv(buf, count, static_cast< ::MPI_Datatype>(datatype), &mpi_message, &mpi_status);
+
+    status->mpi_status = new ::MPI_Status(mpi_status);
+    status->ep_src = message->ep_src;
+    status->ep_datatype = datatype;
+    status->ep_tag = message->ep_tag;
+
+    //check_sum_recv(buf, count, datatype, message->ep_src, message->ep_tag);
+
+    return 0;
+	}
+
+
+  
+
+}
